/* PTMovies	-	Display Panorama Movies
   Copyright (C) 2000 - Helmut Dersch  der@fh-furtwangen.de
   
   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  */

/*------------------------------------------------------------*/

import java.applet.*;
import java.awt.*;
import java.awt.event.*;
import java.awt.image.*;
import java.net.*;
import java.net.URLConnection;
import java.util.*;
import java.text.*;
import java.io.*;
import java.lang.reflect.*;
import java.lang.*;


public class ptcompass extends Applet
{
	String PTViewer = "ptviewer";
	int vx = 0, vy = 0;
	int nhor = 24, nver = 1;
	ptviewer pv = null;
	int cnv = -1, cnh = -1;
	Image compass	= null;
 	int[]   cs_data 	= null;					// RGB data compass source
  	int[]   cd_data 	= null;					// RGB data compass dest
	MemoryImageSource cp_source = null;			// Compass source
	double cp_pan			= 0.0;				// Compass data
	int	   cp_x				= 0;
	int	   cp_y				= 0;
	int	   cp_direction		= 1;
	boolean cp_visible		= true;
	boolean cp_dirty		= true;
	
	double yaw 		= 0.0; // impossible value
	double pitch 	= 0.0;
	double hfov 	= 70.0;

	public ptcompass(){}


	public ptcompass( ptviewer p, String properties ){
		pv = p;
		setStub(new ptstub(pv, properties ));
	}	

	
   	public void init(){
   		String s;

 		s = getParameter( "PTViewer"); 		if( s!=null )	PTViewer = s;
		while( pv == null ){		
			try{
				pv = (ptviewer) getAppletContext().getApplet(PTViewer);
			}catch(Exception e){
   				try{ Thread.sleep( 2000 );}				
					catch (InterruptedException ie) {return;}
			}
		}

 		s = getParameter( "compass");		if( s!=null )	{ Setcompass( s ); cp_direction = 1; }
		s = getParameter( "compass_map");	if( s!=null )	{ Setcompass( s ); cp_direction = -1;}
		s = getParameter( "compass_pan");	if( s!=null )	cp_pan = Double.valueOf(s).doubleValue();
		s = getParameter( "compass_x");		if( s!=null )	cp_x = Integer.parseInt(s);
		s = getParameter( "compass_y");		if( s!=null )	cp_y = Integer.parseInt(s);
		
	}
	
	public void start(){
		if( pv!=null){
 			pv.startCommunicating(this);
 		}
   	}
   	
   	public void stop(){
		if(pv != null )
				pv.stopCommunicating(this);
	}
	

	public void paint(Graphics g){
		if( pv == null || compass == null ) return;
 		
 		if( pv.pitch != pitch || pv.yaw != yaw || pv.hfov != hfov){
 			pitch = pv.pitch;
 			yaw = pv.yaw;
 			hfov = pv.hfov;
			SetTheCompass();
			cp_source.newPixels();
		}
		g.drawImage(compass, cp_x, cp_y, pv);
	}
	

 	/** Specify Compass image.
    * Use this function only if the applet is not started.
    * @param s The file name of the Compass image.
	*/
 	public synchronized void Setcompass( String s ){ 
	  	PixelGrabber pg;
	  	
	  	if(pv == null ) return;
		compass = pv.loadImage( s );
		
		if( compass == null ) return;
        cs_data = new int[compass.getWidth(null) * compass.getHeight(null)];
        cd_data = new int[compass.getWidth(null) * compass.getHeight(null)];
        
        
  		pg = new PixelGrabber( compass, 0, 0, compass.getWidth(null), compass.getHeight(null), cs_data, 0, compass.getWidth(null) );
        try { pg.grabPixels(); } 
        catch (InterruptedException e) { return; }

   		SetTheCompass();

       	cp_source 	= new MemoryImageSource(compass.getWidth(null), compass.getHeight(null), cd_data, 0, compass.getWidth(null));
        cp_source.setAnimated(true);
        
       	compass = null;
		 		
 		compass = createImage(cp_source);
  	}
	
	void SetTheCompass()
	{
		int w = compass.getWidth(null), h = compass.getHeight(null), x,y;
		int cos = (int)(Math.cos( (yaw - cp_pan) * Math.PI / 180.0 ) * 256.0);
		int sin = (int)(Math.sin( (yaw - cp_pan) * Math.PI / 180.0 ) * 256.0) * cp_direction;
		int h2 = h/2, w2 = w/2, ch2 = h * 128, cw2 = w * 128;
		int xs,ys,xd,yd,cy,dx,dy;
		int p00, p01, p10, p11;
		
		for(y=0; y<h; y++){
			cy = y*w;
			yd = y-h2;
			for(x=0; x<w; x++){
				xd = x-w2;
				xs = xd*cos - yd*sin + cw2; dx = xs & 0xff; xs = xs >> 8;
				ys = xd*sin + yd*cos + ch2; dy = ys & 0xff; ys = ys >> 8;
				if(xs >= 0 && xs < w && ys >= 0 && ys < h){
			/*		p00 = cs_data[ys*w+xs];
					if( xs + 1 < w )
						p01 = cs_data[ys*w+xs+1];
					else
						p01 = cs_data[ys*w+xs];
					if( ys + 1 < h ) ys++;

					p10 = cs_data[ys*w+xs];
					
					if( xs + 1 < w ) xs++;
					p11 = cs_data[ys*w+xs];
					
					cd_data[cy+x] = bil( p00, p01, p10, p11, dx, dy) & (p00 & 0xff000000);*/
					cd_data[cy+x] = cs_data[ys*w+xs];
				}
				else{
					cd_data[cy+x] = 0;
				}	
			}
		}
	}

}
